/* ====================================================================
 *  Copyright 2004 Edward Rudd and Paul Querna
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 *  Some code based off of mod_dav_svn:
 *     Copyright (c) CollabNet.  All rights reserved.
 *
 */

#include "httpd.h"
#include "http_core.h"
#include "http_config.h"
#include "http_protocol.h"
#include "http_log.h"
#include "apr_tables.h"
#include "apr_hash.h"
#include "svn_repos.h"
#include "mod_svn_view_private.h"

static int sv_view_user(svn_repo_rec * svn, apr_table_t * parms, void *data);

#define SVN_ERROR(err,msg)  \
   if (err != SVN_NO_ERROR) { \
        ap_log_rerror(APLOG_MARK, APLOG_ERR, err->apr_err, r, \
            msg, err->message); \
        return HTTP_INTERNAL_SERVER_ERROR; \
    }

static int sv_view_user(svn_repo_rec * svn, apr_table_t * parms, void *data) 
{
    return OK;
}

static void view_user_register_hooks(apr_pool_t * p)
{
    sv_action_register("view_user", sv_view_user, 0, NULL, p);
}

static const command_rec svn_view_user_cmds[] = {
    {NULL}
};

module AP_MODULE_DECLARE_DATA svn_view_user_module = {
    STANDARD20_MODULE_STUFF,
    NULL,
    NULL,
    NULL,
    NULL,
    svn_view_user_cmds,
    view_user_register_hooks,
};
